#include "ledDisp.h"
#define led 13
#define buzz 12
#define btn 2

byte hh=0,mm=0;
byte ah=0,am=0;
boolean alarm=false;
//////////////////////////////////////////

int
TaskTimer1 = 0,
TaskTimer2 = 0,
TaskTimer3 = 0;
bool
TaskFlag1 = false,
TaskFlag2 = false,
TaskFlag3 = false;
///////////////////////////////////////////


void alarmOff(){
  alarm=false;
}

void setup() {
  // put your setup code here, to run once:
  pinMode(led,OUTPUT);
  pinMode(buzz,OUTPUT);
  pinMode(btn,OUTPUT);
  digitalWrite(led,LOW);
  digitalWrite(buzz,HIGH);
  disp(4,5,6,7,8,9,10,11);

  // ----- configure Timer 2 to generate a compare-match interrupt every 1mS
  noInterrupts();            // disable interrupts
  TCCR2A = 0;                // clear control registers
  TCCR2B = 0;
  TCCR2B |= (1 << CS22) |    // 16MHz/128=8uS
            (1 << CS20) ;
  TCNT2 = 0;                 // clear counter
  OCR2A = 125 - 1;           // 8uS*125=1mS (allow for clock propagation)
  TIMSK2 |= (1 << OCIE2A);   // enable output compare interrupt
  interrupts();              // enable interrupts

  attachInterrupt(0,alarmOff,RISING);
  Serial.begin(9600);
  Serial.setTimeout(10);
}


void loop() {
  //-----------   serial    -----------
  if(Serial.available()>0){
    char ch=Serial.read();
    if(ch=='t'){
      hh=Serial.parseInt();
      mm=Serial.parseInt();
      TaskTimer3=500*(Serial.parseInt());
      Serial.println("Time set!");
    }else if(ch=='a'){
      ah=Serial.parseInt();
      am=Serial.parseInt();
      alarm=true;
      Serial.println("Alarm Set");
    }
  }
  
  // put your main code here, to run repeatedly:
  if (TaskFlag1) {
    TaskFlag1 = false;
    digitalWrite(led, !digitalRead(led));
    if((hh==ah) && (mm==am)){
      digitalWrite(buzz,alarm);
    }else{
      digitalWrite(buzz,0);
    }
  }

  // ----- refresh display
  if (TaskFlag2) {
    TaskFlag2 = false;
    clock(hh,mm); 
  }

  //update time
  if (TaskFlag3) {
    TaskFlag3 = false;
    mm++;
    if(mm==60){
      hh++;
      mm=0; 
      if(hh==24){
        hh=0;
      }
    }
  }
  

}



// -------------------------------
// task scheduler (1mS interrupt)
// -------------------------------
ISR(TIMER2_COMPA_vect)
{
  // ----- timers
  /*
     Each timer counts the number of milliseconds since its associated task was
     last performed. Each additional task requires another timer and flag.
  */
  TaskTimer1++;
  TaskTimer2++;
  TaskTimer3++;

  // ----- task1
  if (TaskTimer1 > 250 - 1) { // toggle LED (500mS)
    TaskTimer1 = 0;
    TaskFlag1 = true;
  }

  // ----- task2
  if (TaskTimer2 > 2 - 1) {  // refresh display (2mS)
    TaskTimer2 = 0;
    TaskFlag2 = true;
  }

  // ------ task3
  if (TaskTimer3 > (500*60) - 3) {  //time++
    TaskTimer3 = 0;
    TaskFlag3 = true;
  }

}
